#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "tmidi.h"
#include "define.h"

/*****************************************************
 Mantenimiento: Tomás Pérez García
 
Proyecto "midi2letra"
---------------------
	PFC Ingeniería Técnica en Telecomunicación: Sonido e Imagen, 2009
AUTOR: José Javier Valero Mas
TUTOR: José Manuel Iñesta Quereda
******************************************************/


char*
formatearSalida(char *texto, char *variable)
{
	char *aux;
	char *salida;

	//printf("********************* %s\n", texto);
	//printf("********************* %s\n", variable);
	
	salida = strdup("");
	aux = malloc(sizeof(char)*(NBLANKS+10));
	
	salida = concat(salida, texto, cEOA);
	sprintf(aux, "%*s", NBLANKS-strlen(texto), "");
	salida = concat(salida, aux, cEOA);
	salida = concat(salida, variable, "\n", cEOA);
		
	free(aux);

	return salida;
}


char*
extraerDescriptores(TMidi m)
{
	int i, j, k;
	char *salida, *aux;
	int numnota;

  	salida = strdup("");
  	aux = (char*)malloc(sizeof(char)*100);
  	
  	//mostrar resolucion
  	sprintf(aux, "%d", m.descriptores.division);
  	salida = concat(salida, ";r " , aux, "\n",cEOA);

  	//recorrer todas las pistas
  	for(i=0;i<m.cabecera.numpistas;i++)
  	{
    	sprintf(aux, "------ Text of track %d ----", i);
    	salida = concat(salida, aux, "\n", cEOA);

    	//mostar tempo solo en la pista 0
    	if(i==0)
    	{
    	  	//tempo
    	  	if(m.descriptores.tempo == -1)
    	  		sprintf(aux,"none");
    	  	else
    	  		sprintf(aux,"%.*f", NDEC, m.descriptores.tempo);
    	  	salida = concat(salida, "t ", aux, "\n", cEOA);

    	}
    	
   		//metaeventtext
//    	sprintf(aux, "%d", m.pistas[i].descriptores.maxPolyphony);
//    	salida = concat(salida, formatearSalida("text metaevent:", m.pistas[i].descriptores.texto), cEOA);

    	for(j=0; j<m.pistas[i].cabecera.numeventos;j++)
    	{
    		if(m.pistas[i].evento[j].mensaje == TEXTO 
    				|| m.pistas[i].evento[j].mensaje == COPYRIGTH 
    				|| m.pistas[i].evento[j].mensaje == NOM_PISTA
    				|| m.pistas[i].evento[j].mensaje == NOM_INST)
    		{
	        	//sprintf(aux, "%d", m.pistas[i].evento[j].tini);
	    		//salida = concat(salida, aux, "; ", m.pistas[i].evento[j].texto, "\n", cEOA);
    			salida = concat(salida, "; ", m.pistas[i].evento[j].texto, "\n", cEOA);
    		}
    		else
    		{
	    		if(m.pistas[i].evento[j].mensaje == LETRA)
	    		{
	    			
	    			numnota = 0;
	    			
	    			for(k=0; k<m.pistas[i].cabecera.numnotas; k++)
	    			{
	    				if(m.pistas[i].nota[k].inicio == m.pistas[i].evento[j].tini
	    						|| m.pistas[i].nota[k].inicio == (m.pistas[i].evento[j].tini+1)
	    						|| m.pistas[i].nota[k].inicio == (m.pistas[i].evento[j].tini-1))
	    				{
	    					if(k > 0)
	    						numnota = k;
	    						
	    					k = m.pistas[i].cabecera.numnotas;
	    				}
	    			}
	    			
	    			
		        	//sprintf(aux, "%d", m.pistas[i].evento[j].tini);
	    			sprintf(aux, "%d", m.pistas[i].nota[numnota].inicio);
	    			salida = concat(salida, aux, " ",cEOA);
/*
	    			//tini
		        	sprintf(aux, "%d", m.pistas[i].evento[j].tini);
	    			salida = concat(salida, aux, " ",cEOA);
*/
	    			sprintf(aux, "%d", m.pistas[i].nota[numnota].duracion);
	    			salida = concat(salida, aux, " ",cEOA);

	    			salida = concat(salida, m.pistas[i].evento[j].texto, "\n", cEOA);
	    		}
    		}
    	}
 	}
	//salida = concat(salida, "******************************************************************", "\n", cEOA);

  	return salida;
	//return "";
}

char*
extraerDescriptores2(TMidi m)
{
	int i, j, k;
	char *salida, *aux;
	int numnota;

  	salida = strdup(""); //Memoria para el puntero
  	aux = (char*)malloc(sizeof(char)*100); //Memoria para la variable auxiliar
  	
  	//Mostrar resolución
  	sprintf(aux, "%d", m.descriptores.division);
  	salida = concat(salida, ";r " , aux, "\n",cEOA);

  	//Recorrer todas las pistas
  	for(i=0;i<m.cabecera.numpistas;i++){
    		sprintf(aux, "------ Text of track %d ----", i);
    		salida = concat(salida, aux, "\n", cEOA);

    		//mostar tempo solo en la pista 0
    		if(i==0){
    	  		//tempo
    	  		if(m.descriptores.tempo == -1)
    	  			sprintf(aux,"none");
    	  		else
    	  			sprintf(aux,"%.*f", NDEC, m.descriptores.tempo);
    	  		salida = concat(salida, "t ", aux, "\n", cEOA);
    		}
    

    		for(j=0; j<m.pistas[i].cabecera.numeventos;j++){ //Recorremos por eventos

    			if(m.pistas[i].evento[j].mensaje == TEXTO 
    				|| m.pistas[i].evento[j].mensaje == COPYRIGTH 
    				|| m.pistas[i].evento[j].mensaje == NOM_PISTA
    				|| m.pistas[i].evento[j].mensaje == NOM_INST){ //Si encontramos metadato texto, copyright, nombre de pista o instrumento

    				salida = concat(salida, "; ", m.pistas[i].evento[j].texto, "\n", cEOA);

    			}else{  //Si no es de los anteriores
	    			if(m.pistas[i].evento[j].mensaje == LETRA){ //Si es letra 

	    				numnota = 0; //Asumimos que si hay letra hay nota

	    				for(k=0; k<m.pistas[i].cabecera.numnotas; k++){  //Recorremos por numero de notas
	    					if(m.pistas[i].nota[k].inicio == m.pistas[i].evento[j].tini
	    						|| m.pistas[i].nota[k].inicio == (m.pistas[i].evento[j].tini+10)
	    						|| m.pistas[i].nota[k].inicio == (m.pistas[i].evento[j].tini-10)){
	    					
							if(k > 0) numnota = k;	    						
	    						k = m.pistas[i].cabecera.numnotas;
	    					}
	    				}
	    			
	    				sprintf(aux, "%d", m.pistas[i].nota[numnota].inicio);
	    				salida = concat(salida, aux, " ",cEOA);

	    				sprintf(aux, "%d", m.pistas[i].nota[numnota].duracion);
	    				salida = concat(salida, aux, " ",cEOA);

	    				salida = concat(salida, m.pistas[i].evento[j].texto, "\n", cEOA);
	    
				}
    			}
    		}
 	}

  	return salida;
}




int
main(int argc, char **argv)
{
	/*Para utilizar:
	./midi2letra argumento archivo_midi
		argumento --> -p: Partitura Csound
			      -c: Resultado en consola
	*/
	int error, ok,aux;
	char* salida;
	TMidi midi;

	
	error = 0;
	salida = NULL;

	CargaMidi(&midi, argv[2], &ok);
	if(ok){
		if(!strcmp(argv[1],"-p")){
			srand(time(NULL)); //Damos un valor inicial a la "semilla" de la función rand() y así hacemos la función más aleatoria.
			fichero_partitura(midi,&aux);
			if(!aux) printf("Se ha podido abrir el archivo de salida\n");
			else printf("No se ha podido abrir el fichero de salida\n");
		}else if(!strcmp(argv[1],"-c")){
			salida = extraerDescriptores2(midi);
			printf("%s", salida);
		}
	}else{
	    	fprintf(stderr, "Error: can not open file %s\n", argv[2]);
		salida=strdup("Utilización: ./midi2letra argumento archivo.mid\n\targumentos:\n\t\t\t-p: Partitura Csound\n\t\t\t-o: Resultado en consola");
		printf("%s\n",salida);
		error = 1;
	}


	if(salida != NULL) free(salida);
	
	return(0);
}
